package com.sky.ioc.controller.operation;

import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.service.carbon.CarbonService;
import com.sky.ioc.tool.ReturnMsg;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * TODO
 *
 * @Description
 * @Author LunCe
 * @Date 2023/3/6 10:06
 **/


@Api(tags ="智慧运营----运营分析")
@Slf4j
@RestController
@RequestMapping("/analyse")
public class AnalyseController {


    @Autowired
    private CarbonService carbonService;

    @ApiOperation("核心指标")
    @PostMapping("/getAnalyseCoreIndicators")
    public ReturnMsg getAnalyseCoreIndicators(@RequestBody IocDateParam iocDateParam){
        return carbonService.getAnalyseCoreIndicators(iocDateParam);
    }




    @ApiOperation("用水核心指标")
    @PostMapping("/getAnalyseWaterCoreIndicators")
    public ReturnMsg getAnalyseWaterCoreIndicators(@RequestBody IocDateParam iocDateParam){
        return carbonService.getAnalyseWaterCoreIndicators(iocDateParam);
    }



    @ApiOperation("用电核心指标")
    @PostMapping("/getAnalysePowerCoreIndicators")
    public ReturnMsg getAnalysePowerCoreIndicators(@RequestBody IocDateParam iocDateParam){
        return carbonService.getAnalysePowerCoreIndicators(iocDateParam);
    }


    @ApiOperation("用热核心指标")
    @PostMapping("/getAnalyseHotCoreIndicators")
    public ReturnMsg getAnalyseHotCoreIndicators(@RequestBody IocDateParam iocDateParam){
        return carbonService.getAnalyseHotCoreIndicators(iocDateParam);
    }

    @ApiOperation("用冷核心指标")
    @PostMapping("/getAnalyseColdCoreIndicators")
    public ReturnMsg getAnalyseColdCoreIndicators(@RequestBody IocDateParam iocDateParam){
        return carbonService.getAnalyseColdCoreIndicators(iocDateParam);
    }


    @ApiOperation("光伏核心指标")
    @PostMapping("/getAnalyseCpvCoreIndicators")
    public ReturnMsg getAnalyseCpvCoreIndicators(@RequestBody IocDateParam iocDateParam){
        return carbonService.getAnalyseCpvCoreIndicators(iocDateParam);
    }


    @ApiOperation("总能源趋势")
    @PostMapping("/getEnergyTrendsTotal")
    public ReturnMsg getEnergyTrendsTotal(){
        return carbonService.getEnergyTrendsTotal();
    }


    @ApiOperation("光伏能源趋势")
    @PostMapping("/getEnergyTrendsAnalyseCpv")
    public ReturnMsg getEnergyTrendsAnalyseCpv(){
        return carbonService.getEnergyTrendsAnalyseCpv();
    }
    @ApiOperation("光伏能源分布中的图表")
    @PostMapping("/getEnergyTrendsAnalyseCpvInfo")
    public ReturnMsg getEnergyTrendsAnalyseCpvInfo(){
        return carbonService.getEnergyTrendsAnalyseCpvInfo();
    }

    @ApiOperation("用冷能源趋势")
    @PostMapping("/getEnergyTrendsAnalyseCold")
    public ReturnMsg getEnergyTrendsAnalyseCold(){
        return carbonService.getEnergyTrendsAnalyseCold();
    }

    @ApiOperation("用热能源趋势")
    @PostMapping("/getEnergyTrendsAnalyseHot")
    public ReturnMsg getEnergyTrendsAnalyseHot(){
        return carbonService.getEnergyTrendsAnalyseHot();
    }


    @ApiOperation("用电能源趋势")
    @PostMapping("/getEnergyTrendsAnalysePower")
    public ReturnMsg getEnergyTrendsAnalysePower(){
        return carbonService.getEnergyTrendsAnalysePower();
    }

    @ApiOperation("用热能源趋势")
    @PostMapping("/getEnergyTrendsAnalyseWater")
    public ReturnMsg getEnergyTrendsAnalyseWater(){
        return carbonService.getEnergyTrendsAnalyseWater();
    }


}
