package com.sky.ioc.service.Parking.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.service.Parking.ParkingService;
import com.sky.ioc.tool.FalseData;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * TODO 智慧停车
 * @Description
 * @Author LunCe
 * @Date 2023/2/10 13:45
 **/
@Service
public class ParkingServiceImpl implements ParkingService {


    @Override
    public ReturnMsg getCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",2000);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",180);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",20);
        objects.get(2).put("compare",-0.4);

        objects.get(3).put("value",40);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("建议增加停车位180个");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getTrafficflowSituation(IocDateParam iocDateParam) {
        String[] param = {"getInto","leave"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getVacantParkingSpace(IocDateParam iocDateParam) {
        return ReturnMsg.ok(ReturnMsg.fail());
    }
    @Override
    public ReturnMsg getParkingSpaceDetails(IocDateParam iocDateParam) {
        return ReturnMsg.ok(FalseData.REPORTFORMSLIST5);
    }


    @Override
    public ReturnMsg getStopViolation(IocDateParam iocDateParam) {
        return ReturnMsg.ok(FalseData.REPORTFORMSLIST2);
    }

    @Override
    public ReturnMsg getOccupationOfParkingSpace(IocDateParam iocDateParam) {
        return ReturnMsg.ok(FalseData.REPORTFORMSLIST2);
    }


}
