package com.sky.ioc.service.assets.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.service.assets.AssetService;
import com.sky.ioc.tool.FalseData;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TODO
 * @Description 资产
 * @Author LunCe
 * @Date 2023/2/23 17:04
 **/

@Service
public class AssetServiceImpl implements AssetService {
    @Override
    public ReturnMsg getInvestmentDistribution() {
        String[] param = {"investment1","investment2","investment3","investment4","rateReturn"};
        String[] labKey = {"1季度","2季度","3季度","4季度"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getAssetLife() {
        String[] param = {"serviceLife","standardLife"};
        String[] labKey = {"资产1","资产2","资产3","资产4","资产5","资产6"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getAssetCount() {
        Map<String, Object> map = new HashMap<>();
        map.put("yearCount","12000");
        map.put("yearCountYoy","0.4%");
        map.put("totalAssetCount","2100");
        map.put("totalAssetCountYoy","0.2%");
        map.put("totalAssetsPerSapita","15");
        map.put("averageServiceLifeOfAssets","10");
        map.put("worthAttention","内容");
        return  ReturnMsg.ok(map);
    }

    @Override
    public ReturnMsg getOperAssetCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",1.3);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",5000);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value","项目1");
        objects.get(2).put("compare",60);

        objects.get(3).put("value","工业互联网");
        objects.get(3).put("compare",60);
        indeicator.setWorthAttention("13笔记本即将到报废年限");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAssetAnalysis(IocDateParam iocDateParam) {
        String[] param = {"investment1","investment2","investment3","investment4","rateReturn"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getAssetShareRanking(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getScrapAndMaintain(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getAssetCoreIndicators() {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",12000);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",2100);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",21);
        objects.get(2).put("compare",-0.4);

        objects.get(3).put("value",12);
        indeicator.setWorthAttention("内容");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAssetAge(IocDateParam iocDateParam) {
        String[] param = {"assetsName","rateReturn"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }
}
