package com.sky.ioc.service.carbon.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.service.carbon.CarbonService;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.security.PublicKey;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ThreadLocalRandom;

/**
 * TODO  双碳
 * @Description
 * @Author LunCe
 * @Date 2023/2/22 11:40
 **/

@Service
public class CarbonServiceImpl implements CarbonService {




    /**
     * TODO  智能看板 --碳配额
     * @Description
     * @Return com.sky.ioc.tool.ReturnMsg
     * @Author LunCe
     * @date 2023/2/22 11:41
     */
    @Override
    public ReturnMsg getCarbonQuota() {
        String[] param = {"consumed","carbonQuota"};
        String[] labelKey = {"总部","规划院","郑分","广分","上分"};
        List<Label> labels = GeneralMethod.getInstance().dataGeneration(param, labelKey);
        return ReturnMsg.ok(labels);
    }

    @Override
    public ReturnMsg getPrintingCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",10);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",80);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",80);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",80);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("今日人流高峰在9:00/17:00，记得提前做好应对喔");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getPrintingCostTrend(IocDateParam iocDateParam) {
        String[] param = {"cost"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getConferenceRoomInfo(IocDateParam iocDateParam) {
        String[] param = {"print","inkCartridge"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getBusCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",100);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",80);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",80);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",80);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("增加20个公车数量");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getBusInfo(IocDateParam iocDateParam) {
        String[] param = {"averageDuration","numberTrips"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getBusCostTrend(IocDateParam iocDateParam) {
        String[] param = {"cost"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getFloorCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",60);

        objects.get(1).put("value",500);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",380);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",80);
        objects.get(3).put("compare",0.4);
        objects.add(new JSONObject());
        objects.get(4).put("value",40);
        objects.get(4).put("compare",0.4);

        indeicator.setWorthAttention("减少2辆车出行一周");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getCarbonInfo(IocDateParam iocDateParam) {
        String[] param = {"zhongxun","guihuayuanBJ","zhengfen","guangfen","shangfen","chengfen"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getCarbonQuotaComposition(IocDateParam iocDateParam) {
        String[] param = {"stock","consume"};
        String[] labKey = {"中旬","规划院","成分","上分","广分","郑分"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getCarbonNews(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getCarbonProportion(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getVehicleCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",60);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",5);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",80);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("减少2辆车出行一周");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getVehicleInfo(IocDateParam iocDateParam) {
        String[] param = {"zhongxun","guihuayuanBJ","zhengfen","guangfen","shangfen","chengfen"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getVehicleInfoOrder(IocDateParam iocDateParam) {
        String[] param = {"Vehicle"};
        String[] labKey = {"中旬","规划院","成分","上分","广分","郑分"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getPrintCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",60);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",500);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",80);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("限制人均每天打印100张以内");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getPrintInfoOrder(IocDateParam iocDateParam) {
        String[] param = {"Print"};
        String[] labKey = {"中旬","规划院","成分","上分","广分","郑分"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getPrintInfo(IocDateParam iocDateParam) {
        String[] param = {"zhongxun","guihuayuanBJ","zhengfen","guangfen","shangfen","chengfen"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getPhotovoltaicInfoOrder(IocDateParam iocDateParam) {
        String[] param = {"Photovoltaic"};
        String[] labKey = {"中旬","规划院","成分","上分","广分","郑分"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getPhotovoltaicInfo(IocDateParam iocDateParam) {
        String[] param = {"zhongxun","guihuayuanBJ","zhengfen","guangfen","shangfen","chengfen"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getPhotovoltaicCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",60);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",500);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",80);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("建议扩大光伏发电面积");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getPhotovoltaicPower() {
        String[] param = {"realTime"};
        String[] labelKey = {"8:00-10:00","10:00-12:00","12:00-14:00","14:00-16:00","16:00-18:00"};
        List<Label> labels = GeneralMethod.getInstance().dataGeneration(param, labelKey);
        return ReturnMsg.ok(labels);
    }


    @Override
    public ReturnMsg getAnalyseCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("人均成本过高，请购买智能源服务");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAnalyseWaterCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("人均成本过高，请购买智能源服务");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAnalysePowerCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",30);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("人均成本过高，请购买智能源服务");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAnalyseHotCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("人均成本过高，请购买智能源服务");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAnalyseColdCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("人均成本过高，请购买智能源服务");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAnalyseCpvCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("人均成本过高，请购买智能源服务");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getPhotovoltaicProfit() {
        ThreadLocalRandom current = ThreadLocalRandom.current();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("amountSubsidy",current.nextInt(50,150));
        jsonObject.put("saving",current.nextInt(50,150));
        return ReturnMsg.ok(jsonObject);
    }

    @Override
    public ReturnMsg getEnergyTrendsAnalyseWater() {
        String[] param = {"tapWater","recycledWater"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnergyTrendsAnalysePower() {
        String[] param = {"tip","seal","flat","valley"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnergyTrendsAnalyseHot() {
        String[] param = {"heatConsumption"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnergyTrendsAnalyseCold() {
        String[] param = {"refrigerationCapacity","energyConsumption"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnergyTrendsAnalyseCpv() {
        String[] param = {"powerGeneration","outputPower"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnergyTrendsTotal() {
        String[] param = {"water","cpv","cold","hot","power"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnergyTrendsAnalyseCpvInfo() {
        String[] param = {"governmentSubsidies","save"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

}
