package com.sky.ioc.service.fitness.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.service.fitness.HealthService;
import com.sky.ioc.tool.FalseData;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * TODO 健康小屋
 * @Description
 * @Author LunCe
 * @Date 2023/2/10 17:35
 **/

@Service
public class HealthServiceImpl implements HealthService {
    @Override
    public ReturnMsg getCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",100);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",20);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",21);
        objects.get(2).put("compare",-0.4);
        objects.get(3).put("value","高血压");
        indeicator.setWorthAttention("员工腰椎问题持续上升");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getHutAnalysis(IocDateParam iocDateParam) {
        String[] param = {"warehousing","physicalExamination"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getEnvironmentalDetection(IocDateParam iocDateParam) {
        return ReturnMsg.ok(FalseData.REPORTFORMSLIST3);
    }
}
