package com.sky.ioc.service.personnel.impl;

import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.entity.result.dashboard.Personnel;
import com.sky.ioc.service.personnel.PersonnelService;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * TODO  人员
 * @Description
 * @Author LunCe
 * @date 2023/2/22 15:14
 */
@Service
public class PersonnelServiceImpl implements PersonnelService {



    @Override
    public ReturnMsg personnelInfoCount() {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",2000);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",20);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",1800);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",100);
        objects.get(3).put("compare",-0.4);
        indeicator.setWorthAttention("本周上班时间持续延后");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    //查询智能看板统计画像的统计人员信息报表
    @Override
    public ReturnMsg getPersonnelInfoList() {
//        List<Personnel> list = new ArrayList<>();
//        SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd");
//        Calendar c = Calendar.getInstance();
//        c.add(Calendar.MONTH, -5);
//        list.add(new Personnel(20, 30, 40, new Date()));
//        list.add(new Personnel(16, 191, 118, new Date()));
//        list.add(new Personnel(38, 28, 28, new Date()));
//        return ReturnMsg.ok(list);
        String[] param = {"ownEmployees","outsourcingStaff","visitors"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getSecurityCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",2000);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",5000);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",200);
        objects.get(2).put("compare",60);

        objects.get(3).put("value",20);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("防控疫情，缩减访客预约");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getPopulationPerson(IocDateParam iocDateParam) {
        String[] param = {"numberPeople"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getPassengerFlow(IocDateParam iocDateParam) {
        String[] param = {"Freelance","other"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

}
