package com.sky.ioc.service.space.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sky.ioc.entity.Indeicator;
import com.sky.ioc.entity.Label;
import com.sky.ioc.entity.params.IocDateParam;
import com.sky.ioc.service.space.SpaceService;
import com.sky.ioc.tool.GeneralMethod;
import com.sky.ioc.tool.ReturnMsg;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * TODO  空间
 * @Description
 * @Author LunCe
 * @Date 2023/2/22 11:44
 **/
@Service
public class SpaceServiceImpl implements SpaceService {

    /**
     * TODO  智能看板 -- 楼宇态势
     * @Description
     * @Return com.sky.ioc.tool.ReturnMsg
     * @Author LunCe
     * @date 2023/2/22 11:45
     */
    @Override
    public ReturnMsg getBuildingSituation() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("builtArea",112893);
        jsonObject.put("layersInt",21);
        jsonObject.put("serviceLife",60);
        jsonObject.put("constructionPeriod",80);
        return ReturnMsg.ok(jsonObject);
    }

    @Override
    public ReturnMsg getFloorCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",90);
        objects.get(1).put("value",500);
        objects.get(2).put("value",380);
        objects.get(3).put("value",80);
        objects.add(new JSONObject());
        objects.add(new JSONObject());
        objects.get(4).put("value",40);
        objects.get(5).put("value",20);
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getAccessPersonnel(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getFloorList(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getMeetingCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",95);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",80);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",80);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",8);
        objects.get(3).put("compare",0.4);
        indeicator.setWorthAttention("增加会议室");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }


    @Override
    public ReturnMsg getConferenceRoomInfo(IocDateParam iocDateParam) {
        return null;
    }

    @Override
    public ReturnMsg getMeetingCostTrend(IocDateParam iocDateParam) {
        String[] param = {"shichang","bangong","chanpin","zhihui","yewu","qita"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getSpaceInfo(IocDateParam iocDateParam) {
        String[] param = {"administrativeArea","leisureArea"};
        String[] labKey = {"1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"};
        List<Label> labels1 = GeneralMethod.getInstance().dataGeneration(param, labKey);
        return ReturnMsg.ok(labels1);
    }

    @Override
    public ReturnMsg getSpaceCoreIndicators(IocDateParam iocDateParam) {
        Indeicator indeicator = new Indeicator();
        List<JSONObject> objects = indeicator.getList();
        objects.get(0).put("value",98);
        objects.get(0).put("compare",0.4);

        objects.get(1).put("value",50);
        objects.get(1).put("compare",0.4);

        objects.get(2).put("value",100);
        objects.get(2).put("compare",0.4);

        objects.get(3).put("value",1000);
        objects.get(3).put("compare",0.4);
        objects.add(new JSONObject());
        objects.get(4).put("value","40/100");
        objects.get(4).put("compare",0.4);

        indeicator.setWorthAttention("会议室使用率过低，建议出租");
        indeicator.setList(objects);
        return ReturnMsg.ok(indeicator);
    }

    @Override
    public ReturnMsg getSpaceOverview() {
        JSONArray jsonArray = new JSONArray();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("total",2000);
        jsonObject.put("occupancy",1800);
        jsonObject.put("percentage",0.75);

        JSONObject jsonObject2 = new JSONObject();
        jsonObject2.put("total",2000);
        jsonObject2.put("occupancy",1800);
        jsonObject2.put("percentage",0.97);

        JSONObject jsonObject3 = new JSONObject();
        jsonObject3.put("total",2000);
        jsonObject3.put("occupancy",1800);
        jsonObject3.put("percentage",0.93);
        jsonArray.add(jsonObject);
        jsonArray.add(jsonObject2);
        jsonArray.add(jsonObject3);


        JSONObject jsonObject1 = new JSONObject();
        jsonObject1.put("data",jsonArray);
        return ReturnMsg.ok(jsonObject1);
    }
}
